unit ThiefTlpConfigUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles;

type
  TfrmConfig = class(TForm)
    edtTelop: TEdit;
    lblTelop: TLabel;
    btnStartTelop: TButton;
    FontDialog1: TFontDialog;
    btnFont: TButton;
    imgDesktop: TImage;
    Label1: TLabel;
    edtInterval: TEdit;
    Label2: TLabel;
    edtScrollPixel: TEdit;
    grbTelopPreview: TGroupBox;
    lblTelopPreview: TLabel;
    btnVersionInfo: TButton;
    Button1: TButton;
    procedure btnFontClick(Sender: TObject);
    procedure btnStartTelopClick(Sender: TObject);
    procedure btnVersionInfoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure edtTelopChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmConfig: TfrmConfig;

  // INIt@C̓ǂݍݗp
  TELOP_TEXT: String;      // eLXg
  INTERVAL: Integer;       // C^[o
  SCROLL_PIXEL: Integer;   // XN[sNZ

  FONT_NAME: String;       // tHg
  FONT_BOLD: Boolean;      // 
  FONT_ITALIC: Boolean;    // Α
  FONT_UNDERLINE: Boolean; // 
  FONT_STRIKEOUT: Boolean; // 
  FONT_SIZE: Integer;      // TCY
  FONT_COLOR: Integer;     // F
  FONT_CHARSET: Integer;   // Zbg

implementation

uses ThiefTlpUnitMain, ThiefTlpUnitVersionInfo;

{$R *.dfm}

procedure TfrmConfig.btnFontClick(Sender: TObject);
begin
 if FontDialog1.Execute then
 begin
  frmMain.lblTelop.Font:=FontDialog1.Font;
  lblTelopPreview.Font:=FontDialog1.Font;
 end;
end;

procedure TfrmConfig.btnStartTelopClick(Sender: TObject);
begin
 frmMain.tmrMain.Interval:=StrToInt(edtInterval.Text);
 scrollPixel:=StrToInt(edtScrollPixel.Text);

 frmMain.lblTelop.Caption:=edtTelop.Text;
 frmMain.lblTelop.Font:=FontDialog1.Font;
 self.Hide;
 frmMain.Show;
end;

procedure TfrmConfig.btnVersionInfoClick(Sender: TObject);
begin
 frmVersionInfo.ShowModal;
end;

procedure TfrmConfig.Button1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TfrmConfig.edtTelopChange(Sender: TObject);
begin
 lblTelopPreview.Caption:=edtTelop.Text;
end;

procedure TfrmConfig.FormCreate(Sender: TObject);
var
 IniFile: TIniFile;
 fontStyle: TFontStyles;
begin
 // INIt@Cǂݍ
 IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 try
  TELOP_TEXT:=IniFile.ReadString('THIEF_TELOP','TELOP_TEXT','ebveLXg');
  INTERVAL:=IniFile.ReadInteger('THIEF_TELOP','INTERVAL',1);
  SCROLL_PIXEL:=IniFile.ReadInteger('THIEF_TELOP','SCROLL_PIXEL',2);

  FONT_NAME:=IniFile.ReadString('THIEF_TELOP','FONT_NAME','lr oSVbN');
  FONT_BOLD:=IniFile.ReadBool('THIEF_TELOP','FONT_BOLD',false);
  FONT_ITALIC:=IniFile.ReadBool('THIEF_TELOP','FONT_ITALIC',false);
  FONT_UNDERLINE:=IniFile.ReadBool('THIEF_TELOP','FONT_UNDERLINE',false);
  FONT_STRIKEOUT:=IniFile.ReadBool('THIEF_TELOP','FONT_STRIKEOUT',false);
  FONT_SIZE:=IniFile.ReadInteger('THIEF_TELOP','FONT_SIZE',36);
  FONT_COLOR:=IniFile.ReadInteger('THIEF_TELOP','FONT_COLOR',16777215);
  FONT_CHARSET:=IniFile.ReadInteger('THIEF_TELOP','FONT_CHARSET',128);
 finally
  IniFile.Free;
 end;

 // ǂݍ񂾓eʂɔf
 edtTelop.Text:=TELOP_TEXT;
 edtInterval.Text:=IntToStr(INTERVAL);
 edtScrollPixel.Text:=IntToStr(SCROLL_PIXEL);
 lblTelopPreview.Caption:=TELOP_TEXT;

 FontDialog1.Font.Name:=FONT_NAME;

 if FONT_BOLD then Include(fontStyle,fsBold);
 if FONT_ITALIC then Include(fontStyle,fsItalic);
 if FONT_UNDERLINE then Include(fontStyle,fsUnderline);
 if FONT_STRIKEOUT then Include(fontStyle,fsStrikeOut);
 FontDialog1.Font.Style:=fontStyle;

 FontDialog1.Font.Size:=FONT_SIZE;
 FontDialog1.Font.Color:=FONT_COLOR;
 FontDialog1.Font.Charset:=FONT_CHARSET;

 lblTelopPreview.Font:=FontDialog1.Font;
end;

procedure TfrmConfig.FormDestroy(Sender: TObject);
var
 IniFile: TIniFile;
begin
 // INIt@C
 IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 try
  IniFile.WriteString('THIEF_TELOP','TELOP_TEXT',edtTelop.Text);
  IniFile.WriteInteger('THIEF_TELOP','INTERVAL',StrToInt(edtInterval.Text));
  IniFile.WriteInteger('THIEF_TELOP','SCROLL_PIXEL',StrToInt(edtScrollPixel.Text));

  IniFile.WriteString('THIEF_TELOP','FONT_NAME',FontDialog1.Font.Name);
  IniFile.WriteBool('THIEF_TELOP','FONT_BOLD',fsBold in FontDialog1.Font.Style);
  IniFile.WriteBool('THIEF_TELOP','FONT_ITALIC',fsItalic in FontDialog1.Font.Style);
  IniFile.WriteBool('THIEF_TELOP','FONT_UNDERLINE',fsUnderline in FontDialog1.Font.Style);
  IniFile.WriteBool('THIEF_TELOP','FONT_STRIKEOUT',fsStrikeOut in FontDialog1.Font.Style);
  IniFile.WriteInteger('THIEF_TELOP','FONT_SIZE',FontDialog1.Font.Size);
  IniFile.WriteInteger('THIEF_TELOP','FONT_COLOR',FontDialog1.Font.Color);
  IniFile.WriteInteger('THIEF_TELOP','FONT_CHARSET',FontDialog1.Font.Charset);

 finally
  IniFile.Free;
 end;
end;

procedure TfrmConfig.FormShow(Sender: TObject);
begin
 // ^XNo[ɂ̃EBhE{^\
 ShowWindow(Application.Handle,SW_SHOW);
end;

procedure TfrmConfig.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//ShowMessage(fsBold in FontDialog1.Font.Style);
end;

end.
